// FOTODUINO_control_1_0

//Partes deste programa foram
//obtidas de https://sensorseverywhere.wordpress.com/2012/01/10/60-hz-filter-works/
//onde se faz a remocao do ruido eletromagnetico de 60 Hz.

  int inPin = A0; //analog 0
  volatile int isNewVal=0; //flag for new read, variables changed in an interrupt handler should be declared volatile
  volatile int val; //where to store info from analog 5
 
  int b[]={ -61, 105, -152, -270, -237, -7, 354, 637, 602, 171, -471,-944,-914,-330,505,1104,1104,505,-330,-914,-944,-471,171,602,637,354,-7,-237,-270,-152,105,-61};
  long latestval[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; //Accumulate latest readings here, need longint or it wraps around
  long myval;//this will hold the latest value of the filtered signal
  float mrec[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};//holds latest 3 cycles of filtered 60Hz signal at 500Hz (25 samples)
  float myamp=0; //latest amplitude of the 60Hz filtered, rectified and moving-averaged signal
  float allamp=0;//latest amplitude of UNFILTERED rectified moving-averaged signal
  int myintamp; //this will be an integer version of myamp for sending over serial.
  int myintallamp;//an integer version of the unfiltered amplitude for sending over serial.
  unsigned int mytime=0;//used for checking how long it takes to do things in the loop

  //pinos digitais do arduino para comandar as lampadas
  int ledRed = 2;
  int ledYellow = 3;
  int ledGreen = 4;
  int ledBlue = 5;
  int ledUVA = 6;
  int ledUVC = 7;
  
 
  void setup()//set up interrupts for 500Hz done by Chris Isert

  {

  Serial.begin(115200); //when I check the time delay it’s 2.0 – 2.2 ms
  //Serial.begin(230400); //works better when I check the time delay, I get 2 ms
  // initialize timer1

 //configuracao do pino digital do arduino para PWM da fonte AT 
  pinMode(11, OUTPUT);

 //configuracao dos pinos digitais do controle das lampadas 
  for (int x=2; x<8; x++){
    pinMode(x, OUTPUT); //definindo pinos como saidas digitais
    digitalWrite(x, LOW); //iniciando pinos em nivel baixo
    }

  
  // configuracao pwm
  TCCR2A = _BV(COM2A1) | _BV(COM2B1) | _BV(WGM21) | _BV(WGM20);
  TCCR2B = _BV(CS22);
  OCR2A = 180;
  OCR2B = 50;


// configuracao de registradores
  noInterrupts(); // disable all interrupts
  TCCR1A = 0;
  TCCR1B = 0;
  TCNT1 = 0;
  OCR1A = 32000; // compare match register 16MHz/1/500Hz
  TCCR1B |= (1 << WGM12); // CTC mode
  TCCR1B |= (1 << CS10); // divide-by-1 prescaler
  TIMSK1 |= (1 << OCIE1A); // enable timer compare interrupt
  interrupts(); // enable all interrupts

  }

  ISR(TIMER1_COMPA_vect) // timer compare interrupt service routine

  {

  val = analogRead(inPin);//latest EMF sensor reading
  isNewVal=1;//this is a flag telling the loop that there’s a new value (esta é uma bandeira dizendo ao laço que há um novo valor)

  }

  void loop(){
  
 //filtro de 60 Hz    
  if (isNewVal){
  for (int i=0;i<31;i++){
  latestval[i]=latestval[i+1]; //slide the latest 32 raw values back by one in the array
  }
  latestval[31]=val; //and add the newest raw value on the end
 
  allamp=allamp+(abs(latestval[31])-abs(latestval[6]))*0.126; //calculate pi*latest moving average of the last 25 values of the unfiltered signal, for comparing with the 60-hz filtered amplitude in myintamp
  myintallamp=(int)allamp;
  myval=0;
  for (int i=0; i<32; i++){
  myval=myval+latestval[i]*b[i];
  }
  myamp=myamp-mrec[0]; //set up for moving average by removing oldest element
  for(int i=0;i<24;i++){
  mrec[i]=mrec[i+1];//shift the latest 24 filtered and rectified values back by one in preparation for adding the newest one on the end
  }
 
  mrec[24]=abs(0.126*myval)/10000;//rectified (absolute value) signal, times pi/25, it gives the amplitude of the positive-only ac signal scaled for moving avg of latest 25 pts
 
  myamp=myamp+mrec[24];//latest moving avg over 3 cyc of 60 hz at 500 hz sampling rate
  myintamp=(int)myamp;//this conversion to int makes it much faster to send the value over the serial connection than a float, and code size is smaller
 
  isNewVal=0;//clear new value flag until next interrupt
  mytime=micros(); //check whether we are staying at 500Hz, cant spend too much time number crunching between readings
 
//Envio para o computador via serial
  Serial.println(myintallamp);
    
//Controle das lampadas
 if (Serial.available()>0) //comunicacao serial verifica se o byte recebido do computador esta pronto para leitura
 {
    switch(Serial.read())      //verifica qual caracter recebido
    {
      case 11:                  //caso '11'
        digitalWrite(ledRed, HIGH);
      break;
      
      case 10:
        digitalWrite(ledRed, LOW);
      break;
      
      case 21:                  
        digitalWrite(ledYellow, HIGH);
      break;
      
      case 20:
        digitalWrite(ledYellow, LOW);
      break;
      
      case 31:
        digitalWrite(ledGreen, HIGH);
      break;
      
      case 30:
        digitalWrite(ledGreen, LOW);
      break;
       
      case 41:
        digitalWrite(ledBlue, HIGH);
      break;
      
      case 40:
        digitalWrite(ledBlue, LOW);
      break;
       
      case 51:
        digitalWrite(ledUVA, HIGH);
      break;
      
      case 50:
        digitalWrite(ledUVA, LOW);
      break;
       
      case 61:
        digitalWrite(ledUVC, HIGH);
      break;
      
      case 60:
        digitalWrite(ledUVC, LOW);
      break;
      
      } 
    }
   

}
}

